import "../declarations/unityInstance";
import "../declarations/window";
import { PureComponent } from "react";
import IUnityProps from "../interfaces/unityProps";
export default class Unity extends PureComponent<IUnityProps, {}> {
    /**
     * The Unity context passed by the props.
     * @type {UnityContext}
     */
    private unityContext;
    /**
     * The Unity Loader service instance.
     * @type {UnityLoaderService}
     */
    private unityLoaderService;
    /**
     * A reference to the html canvas element the UnityInstance will use.
     */
    private htmlCanvasElementReference?;
    /**
     * An event that is triggered by the Unity player. This tracks
     * the loading progression of the player. It will send '1' when
     * the loading is completed.
     * @param {UnityInstance} unityInstance
     * @param {number} progression
     */
    private onProgress;
    /**
     * Initialzied the Unity player when the component is mounted.
     */
    componentDidMount(): Promise<void>;
    /**
     * When the component will be unmounted, the UnityInstance will quit.
     */
    componentWillUnmount(): void;
    /**
     * Renders the unity wrapper and player.
     * @returns {React.ReactNode} element
     * @public
     */
    render(): React.ReactNode;
}
//# sourceMappingURL=unity.d.ts.map